* ------------------------------------------------------------------------
* Module......:	XPMOUSE.PRG
* Title.......: MOUSE part of the Expand Library Demonstration Program
* Author......:	Pepijn Smits.
* Date........:	July/August 1992
* Copyright...:	(c)1992 by Softwarebureau Pepijn Smits
* Notes.......:	Clipper 5.01 Demo of the Expand Library
*		Some general MOUSE functions
*		See XPDEMO.RMK For Compile and Link instructions.
* ------------------------------------------------------------------------

Static MouseLan := {'English','French','Dutch','German','Swedish','Finnish','Spanish','Portugese','Italian'}
Static MouseTyp := {'(n/a)','Bus','Serial','InPort','PS/2','HP'}

Function MousInfo()
if XPmouseThere()
	XPalert('~Mouse~ Information',;
		PadR('Mouse Installed.......: '+if(XPmouseThere(),'Yes','No '),60)+";"+;
		PadR('Mouse Buttons.........: '+nTrim(XPmouseButoons()),60)+";"+;
		PadR('Mouse Driver version..: '+Str(XPmouseVer()/100,4,2),60)+";"+;
		PadR('Mouse Sensitivity.....: '+Str(XPmouseSensitivity(),4,0),60)+";"+;
		PadR('Assisted Mouse........: '+if(XPmouseAssist(),'Yes','No '),60)+";"+;		
		PadR('Mouse Language........: '+MouseLan[XPmouseLan()+1],60)+";"+;
		PadR('Mouse Type............: '+MouseTyp[XPmouseTyp()+1],60))
else
	XPalert('~Mouse~ Information',;
		'Mouse Information is not available,;'+;
		'as there is no Mouse installed, install your Mouse or the;'+;
		'Mouse driver (MOUSE.COM) if you want to use the Mouse.')
end
Return (NIL)

Function MousAssi()
XPmouseAssist(XPask(' ~Assisted~ Mouse','Do you want ~Assisted Mouse Pointer Movement~ On?'))
Return (NIL)

Function MousSet()
if XPmouseSet()
	XPmouseSet(XPask(' ~Mouse~ Set','Set the Mouse "~On~"?'))
else
	XPmouseSet(!XPask(' ~Mouse~ Set','Set the Mouse "~Off~"?'))
endif
Return (NIL)

Function MousSens()
Local i := XPalert(' ~Mouse~ Sensitivity ',;
	'Set the ~Mouse sensitivity to:',;
	{'~V~ery slow','~S~low','~M~edium','~F~ast','E~x~tremely Fast'})
do case
	case i = 1
		XPmouseSens(10)
	case i = 2
		XPmouseSens(35)
	case i = 3
		XPmouseSens(60)
	case i = 4
		XPmouseSens(75)
	case i = 5
		XPmouseSens(95)
endcase
Return (NIL)
